import haxegon.*;

class Main {
	

	// new() is a special function that is called on startup.
	function new() {
		Gfx.loadimage("bg0");
		Gfx.loadimage("bg0_inbed");
		Gfx.loadimage("bg0_nojacket");
		Gfx.loadimage("bg0_nojacket_inbed");
		Gfx.loadimage("bg0_nojacket_notent");
		Gfx.loadimage("bg0_nojacket_notent_inbed");
		Gfx.loadimage("bg0_notent");
		Gfx.loadimage("bg0_notent_inbed");
		Gfx.loadimage("bg1");
		Gfx.loadimage("bg1_nojacket");
		Gfx.loadimage("bg1_nojacket_notent");
		Gfx.loadimage("bg1_notent");
		Gfx.loadimage("dream");
		Gfx.loadimage("postdream");

		Gfx.loadimage("p1");
		Gfx.loadimage("p12");
		Gfx.loadimage("p2");
		Gfx.loadimage("p22");	

		Music.loadsound("blip");
//		Gfx.resizescreen(26,35);	
	}

	private var state:Int=0;
	function titleUpdate(){
		Text.display(Text.CENTER,Text.CENTER-20,"VAMPIRE",Col.WHITE);
		Text.display(Text.CENTER,Text.CENTER+50,"press x to start",Col.WHITE);
		if (Input.justpressed(Key.X)){
			state++;
			text="";
		}
	}

	var textcolors:Array<Int> = [0xDE99A3,0xe3d466];
	var scale:Int = 18;
	
	var p1:Int = 21;
	var p2:Int = 40;
	var day:Int = 1;
	var camp:Int = 0;
	var wearingCoat1:Int = 0;
	var wearingCoat2:Int = 1;
	var text:String = "";
	var speaker:Int = 0;
	var inbed = 0;
	var dream = 0;

	function drawCamp(){
		var xoffset = Gfx.screenwidth/2-p1*scale;
		if (xoffset>0){
			xoffset=0;
		}
		day = 1;
		if (p2*scale+xoffset>=Gfx.screenwidth){
			day=0;
		}
		var bgname = "bg"+day;
		if (wearingCoat1==1){
			bgname+="_nojacket";
		}
		if (camp==0){
			bgname+="_notent";
		}
		if (inbed==1){
			bgname+="_inbed";
		}
		if (dream==1){
			bgname="dream";
		}
		Gfx.drawimage(xoffset,0,bgname);
		if (inbed==0){		
			Gfx.drawimage(p1*scale+xoffset,15*scale,wearingCoat1==1?"p12":"p1");
		}
		if (camp==0){
			Gfx.drawimage(p2*scale+xoffset,15*scale,wearingCoat2==1?"p22":"p2");
		}

		if (speaker==0){
			Text.display(Text.LEFT+10,23.5*scale,text,textcolors[speaker]);
		} else {
			Text.display(Text.RIGHT-10,23.5*scale,text,textcolors[speaker]);
		}

		Text.display(0,0,""+p1,Col.BLACK);
	}

	//state 1
	function startUpdate(){
		if (Input.delaypressed(Key.LEFT,2)){
			p1--;
		} 
		if (Input.delaypressed(Key.RIGHT,2)){
			p1++;
		} 

		if (p1+6==p2){
			state++;
				text="";
		}
		if (p1<3){
			p1=3;
		}
		if (p1>168){
			p1=168;
		}
		drawCamp();
	}
	

	var dialogueIndex:Int =0;
	var dialogue1 = [
	["A","Hey! All set to go to the woods?"],
	["B","Do you want to get your jacket first?"], 
	["A","Why? It's lovely and warm"],
	["B","No, it's pretty cold."],
	["B","Want to go back and get your coat?"],
	["A","[Y]es/[N]o"]
	];

	//state 2
	function dialogue1Update(){
		text = dialogue1[dialogueIndex][1];
		speaker = dialogue1[dialogueIndex][0]=="A"?0:1;
		if (dialogueIndex<dialogue1.length-1){
			if (Input.justpressed(Key.X)) {
				dialogueIndex++;
			}
		} else {
			if (Input.justpressed(Key.Y)){
				state++;
				text="";
			} 
			if (Input.justpressed(Key.N)){
				state=5;
				text="";
			} 
		}
		drawCamp();
	}
	
	//state 3
	function jacketPickupUpdate(){
		if (Input.delaypressed(Key.LEFT,2)){
			p1--;
		} 
		if (Input.delaypressed(Key.RIGHT,2)){
			p1++;
		} 


		if (p1>p2-6){
			p1=p2-6;
		}

		if (p1<=11){
			wearingCoat1=1;
			state++;
				text="";
		}

		if (p1<3){
			p1=3;
		}
		if (p1>168){
			p1=168;
		}
		drawCamp();
	}
	
	//state 4
	function jacketReturnUpdate(){

		if (Input.delaypressed(Key.LEFT,2)){
			p1--;
		} 
		if (Input.delaypressed(Key.RIGHT,2)){
			p1++;
		} 

		if (p1+6>=p2){
			state++;
				text="";
		}

		if (p1<3){
			p1=3;
		}
		if (p1>168){
			p1=168;
		}
		drawCamp();
	}
	
	//state 5
	function gotoTreeUpdate(){

		if (Input.delaypressed(Key.LEFT,2)){
			p1--;
		} 
		if (Input.delaypressed(Key.RIGHT,2)){
			p1++;
		} 

		if (p1<=11){
			wearingCoat1=1;
		}

		if (p1+6>p2){
			p2=p1+6;
		}
		if (p1>87){
			dialogueIndex=0;
			state++;
				text="";
		}

		if (p1<3){
			p1=3;
		}
		if (p1>168){
			p1=168;
		}
		if (p2<p1+6){
			p2=p1+6;
		}
		drawCamp();

	}
	

	var dialogue2 = [
	["B","You say you're warm, but you're confused."],
	["A","Pretty sure I'm warm"],
	["B","Sometimes people think they know something"], 
	["B","But they experience the concept very indirectly"],
	["B","Wires can get crossed along the way."],
	["A","What do you mean?"],
	["B","Are you sure it's warm?"],
	["B", "Is there a sensation beyond that?"],
	["A","I guess"],
	["A","I guess...because the sky is blue"],
	["A","I feel I'm warm because the sky is blue."],
	["B","But you're not warm"],
	["A","I feel I am, but I guess not."],
	["A","It's just that the sky is blue."],
	["B","But it's nighttime!"],
	["A","How can that be?"],
	["A","The sky is bright - we just met at dawn."],
	["B","What do you feel?"],
	["A","I...feel the sky is blue..."],
	["A","But I infer that because I'm happy."],
	["B","Let's walk to the beach!"]
	];
	//state 6
	function treeDialogueUpdate(){
		text = dialogue2[dialogueIndex][1];
		speaker = dialogue2[dialogueIndex][0]=="A"?0:1;
		if (dialogueIndex<dialogue2.length-1){
			if (Input.justpressed(Key.X)) {
				dialogueIndex++;
			}
		} else {
			if (Input.justpressed(Key.X)) {
				state++;
				text="";
			} 
		}
		drawCamp();
	}

	//state 7
	function gotoBeachUpdate(){


		if (Input.delaypressed(Key.LEFT,2)){
			p1--;
		} 
		if (Input.delaypressed(Key.RIGHT,2)){
			p1++;
		} 

		if (p1+6>p2){
			p2=p1+6;
		}
		if (p1>149){
			dialogueIndex=0;
			state++;
				text="";
		}

		if (p1<=11){
			wearingCoat1=1;
		}
		if (p1<3){
			p1=3;
		}
		if (p1>168){
			p1=168;
		}
		if (p2<p1+6){
			p2=p1+6;
		}
		drawCamp();
	}
	
	var dialogue3 = [
["B","Hey"],
["B","You happy?"],
["A","Yes"],
["B","The sky's blue?"],
["A","I thought so, but might not... "],
["B","Is it warm?"],
["A","Hard to answer - "],
["B","Are you happy?"],
["A","Yes. I'm certain."],
["B","I'm going to camp here for tonight"],
["B","See you in the morning."],
["B","Safe home"]
];
	//state 8
	function beachdialogueUpdate(){

		text = dialogue3[dialogueIndex][1];
		speaker = dialogue3[dialogueIndex][0]=="A"?0:1;
		if (dialogueIndex<dialogue3.length-1){
			if (Input.justpressed(Key.X)) {
				dialogueIndex++;
			}
		} else {
			if (Input.justpressed(Key.X)) {
				state++;
				text="";
				camp=1;
			} 
		}
		drawCamp();
	}
	
	//state 9
	function beachWestUpdate(){

		if (Input.delaypressed(Key.LEFT,2)){
			p1--;
		} 
		if (Input.delaypressed(Key.RIGHT,2)){
			p1++;
		} 

		if (p1<122){
			state++;
		}

		if (p1<3){
			p1=3;
		}
		if (p1>168){
			p1=168;
		}
		drawCamp();
	}
	
	//state 10
	function itsDarkUpdate(){
		text = "It's dark";
		speaker = 0;
		if (Input.justpressed(Key.X)) {
			state++;
			text="";
		}
		drawCamp();
	}
	
	//state 11
	function westToTreeUpdate(){

		if (Input.delaypressed(Key.LEFT,2)){
			p1--;
		} 
		if (Input.delaypressed(Key.RIGHT,2)){
			p1++;
		} 

		if (p1<81){
			state++;
			text="";
		}

		if (p1<3){
			p1=3;
		}
		if (p1>168){
			p1=168;
		}

		drawCamp();
	}
	
	//state 12
	function iFeelColdUpdate(){
		text = "I'm cold";
		speaker = 0;
		if (Input.justpressed(Key.X)) {
			state++;
			text="";
		}
		drawCamp();

	}
	
	//state 13
	function westTreeToHouseUpdate(){

		if (Input.delaypressed(Key.LEFT,2)){
			p1--;
		} 
		if (Input.delaypressed(Key.RIGHT,2)){
			p1++;
		} 

		if (p1<5){
			state++;
			text="";
		}

		if (p1<3){
			p1=3;
		}
		if (p1>168){
			p1=168;
		}
		
		drawCamp();
	}
	
	//state 14
	function iFeelSadUpdate(){
		text = "I'm sad";
		speaker = 0;
		if (Input.justpressed(Key.X)) {
			state++;
			text="";
			inbed=1;		
		}
		drawCamp();
	}
	
	//state 15
	function goingToBedUpdate(){
		if (Input.justpressed(Key.X)) {
			dream = 1;
			inbed=0;
			camp=0;
			p1=0;
			p2=60;
			state++;
			text="";
		}
		drawCamp();
	}
	
	//state 16
	function dreamSequenceUpdate(){

		if (Input.delaypressed(Key.LEFT,2)){
			p1--;
		} 
		if (Input.delaypressed(Key.RIGHT,2)){
			p1++;
		} 


		if (p1<3){
			p1=3;
		}
		if (p1>168){
			p1=168;
		}
		if (p2<p1+6){
			dream=0;
			p1=4;
			p2=154;
			camp=0;
			state++;
			text="";
			inbed=1;
		}
		drawCamp();
	}
	
	//state 17
	function wakeupUpdate(){

		if (Input.justpressed(Key.X)) {
			dream=0;
			p1=4;
			p2=154;
			camp=0;
			state++;
			text="";
		}
		drawCamp();
	}
	
	//state 18
	function cryingFaceUpdate(){

		if (Input.justpressed(Key.X)) {
			state++;
			dream=0;
			camp=0;
			inbed=0;
			text="";
		}
		Gfx.drawimage(0,0,"postdream");
	}
	
	//state 19
	function returnToTentUpdate(){

		if (Input.delaypressed(Key.LEFT,2)){
			p1--;
		} 
		if (Input.delaypressed(Key.RIGHT,2)){
			p1++;
		} 

		if (p1>=149){
			state++;
			dialogueIndex=0;
			text="";
		}

		if (p1<3){
			p1=3;
		}
		if (p1>168){
			p1=168;
		}
		if (p2<p1+6){
			p2=p1+6;
		}
		drawCamp();
	}
	
	var dialogue4 = [
	["A","I thought I knew what sadness was"],
	["A","But last night I had a dream..."],
	["B","There'll be no talk of sadness here"],
	["B","Let's enjoy the day and go fishing!"]
	];
	//state 20
	function finalConvUpdate(){
		text = dialogue4[dialogueIndex][1];
		speaker = dialogue4[dialogueIndex][0]=="A"?0:1;
		if (dialogueIndex<dialogue4.length-1){
			if (Input.justpressed(Key.X)) {
				dialogueIndex++;
			}
		} else {
			if (Input.justpressed(Key.X)) {
				state++;
			text="";
			} 
		}
		drawCamp();
	}
	
	//state 21
	function endingUpdate(){
		Text.display(Text.CENTER,Text.CENTER-20,"VAMPIRE",Col.WHITE);
	}

	function update() {
		switch(state){
			case 0://title
			titleUpdate();
			case 1://walk to dude
			startUpdate();
			case 2://dialogue 1
			dialogue1Update();
			case 3://going back to house to pick up jacket
			jacketPickupUpdate();
			case 4://walking back to dude with jacket
			jacketReturnUpdate();
			case 5://venturing to tree
			gotoTreeUpdate();
			case 6://tree dialogue
			treeDialogueUpdate();
			case 7://walk to beach
			gotoBeachUpdate();
			case 8://beach dialogue
			beachdialogueUpdate();
			case 9://walk from beach west
			beachWestUpdate();
			case 10://it's dark
			itsDarkUpdate();
			case 11://walk from west to tree
			westToTreeUpdate();
			case 12://I feel cold
			iFeelColdUpdate();
			case 13://walk from tree to house
			westTreeToHouseUpdate();
			case 14://I feel sad
			iFeelSadUpdate();
			case 15://going to sleep in bed
			goingToBedUpdate();
			case 16://dream sequence
			dreamSequenceUpdate();
			case 17://wake up with a start
			wakeupUpdate();
			case 18://detailed picture of crying face
			cryingFaceUpdate();
			case 19://walk back to tent
			returnToTentUpdate();
			case 20://talk to person
			finalConvUpdate();
			case 21://ending
			endingUpdate();
		}

	}
}